package Tester;

import java.awt.Font;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import java.io.File;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.*;
import java.awt.*;

public class Frame extends JFrame{
public String xmlFile;
public String BPELPath;
public int RepetitionNumber;
public int tmax;
public int numberWSDL;
public boolean ex;
private JLabel labelSpec = new JLabel("Timed Automata (XML)");
private JLabel labelBPEL = new JLabel("BPEL implementation ");
    private JLabel labelNombreRepetitions = new JLabel("Test execution number");
    private JLabel labeltmax = new JLabel("Network timeout (milliseconds)");
  
    private JButton boutonParcourir = new JButton("Browse");
    private JButton boutonParcourir1 = new JButton("Browse");
    private JButton boutonExecution = new JButton("Start Test");
    private JTextField jtf1 = new JTextField(".xml");
    private JTextField jtfBPEL = new JTextField(".bpel");
    private JTextField jtf2 = new JTextField();
    private JTextField jtf3 = new JTextField();
    private boutonParcourirListener pl = new boutonParcourirListener();
    private boutonExecutionListener el = new boutonExecutionListener();
    private boutonParcourir1Listener p2 = new boutonParcourir1Listener();
    
    public Frame() {
        try{
            UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
            // On change la locale par dfaut de la JVM :
            java.util.Locale.setDefault(java.util.Locale.ENGLISH);

            // On change la locale par dfaut du LookAndFeel :
            javax.swing.UIManager.getDefaults().setDefaultLocale(java.util.Locale.ENGLISH);

            // On change la locale par dfaut des nouveaux composants :
            javax.swing.JComponent.setDefaultLocale(java.util.Locale.ENGLISH);

            //Dfinit un titre pour votre fentre
            this.setTitle("WSCCT (1.0)");
            //Dfinit une taille pour celle-ci ; ici, 500 px de large et 400 px de haut
            this.setSize(700, 300);
            //Nous allons maintenant dire  notre objet de se positionner au centre
            this.setLocationRelativeTo(null);
            //Empcher le redimensionnement de la fentre
            this.setResizable(true);
            // pas de Layout, nous positionnons les composants nous-mmes
            this.setLayout(null);
            //Terminer le processus lorsqu'on clique sur "Fermer"
            this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
            this.ex = false;


            //dimensions du label
            labelSpec.setBounds(20, 20, 200, 30);
            Font police = new Font("Arial", Font.BOLD, 12);
            //text area ou sera rcupr le chemin du fichier choisi par l utilisateur
            labelSpec.setFont(police);
            jtf1.setFont(police);
            jtf1.setForeground(Color.BLUE);
            jtf1.disable();
            //jtf.setPreferredSize(new Dimension(250, 30));
            jtf1.setBounds(245, 20, 250, 30);
            boutonParcourir.setBounds(500, 20, 90, 30);
            
            
            labelBPEL.setBounds(20, 55, 200, 30);
            labelBPEL.setFont(police);

            jtfBPEL.setFont(police);
            jtfBPEL.setForeground(Color.BLUE);
            jtfBPEL.disable();
            //jtf.setPreferredSize(new Dimension(250, 30));
            jtfBPEL.setBounds(245, 55, 250, 30);
            boutonParcourir1.setBounds(500, 55, 90, 30);
   
            labelNombreRepetitions.setBounds(20, 90, 210, 30);
            labelNombreRepetitions.setFont(police);
            jtf2.setFont(police);
            jtf2.setForeground(Color.BLUE);
            jtf2.setBounds(245, 90, 50, 30);
            labeltmax.setBounds(20, 125, 200, 30);
            labeltmax.setFont(police);
            jtf3.setFont(police);
            jtf3.setForeground(Color.BLUE);
            jtf3.setBounds(245, 125, 50, 30);


            boutonExecution.setBounds(245, 180, 120, 30);
            //boutonQuitter.setBounds(340, 230, 90, 30);
            boutonParcourir.setFont(police);
            boutonParcourir.addActionListener(pl);
            boutonParcourir1.setFont(police);
            boutonParcourir1.addActionListener(p2);
            //boutonQuitter.addActionListener(ql);
            boutonExecution.addActionListener(el);
            boutonExecution.setFont(police);
            //ajout des composants  la fenetre
            this.add(labelSpec);
            this.add(labelBPEL);
            this.add(labelNombreRepetitions);
            this.add(labeltmax);


            this.add(jtf1);
            this.add(jtfBPEL);
            this.add(jtf2);
            this.add(jtf3);
         
            this.add(boutonParcourir);
            this.add(boutonParcourir1);
            this.add(boutonExecution);
            // this.add(boutonQuitter);
            //par dfaut, votre JFrame n'est pas visible donc il faut l'indiquer
            this.setVisible(true);

        } catch (Exception e) {
        }
    }
    
    class boutonParcourirListener implements ActionListener{
             int res;

        public void actionPerformed(ActionEvent e) {
            // System.out.println("TEXT : jtf " + jtf.getText());
            try {

                UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
                UIManager.put("FileChooser.saveButtonText", "Save");
                UIManager.put("FileChooser.openButtonText", "Open");
                UIManager.put("FileChooser.cancelButtonText", "Cancel");
                UIManager.put("FileChooser.updateButtonText", "Refresh");
                UIManager.put("FileChooser.helpButtonText", "Help");
                UIManager.put("FileChooser.saveButtonToolTipText", 
                              "Save File"); //Cration d'une boite de dialogue pour choisir le fichier surlequel appliquer le programme
                JFileChooser fc = new JFileChooser();
                fc.setDialogTitle("Open File");

                //Cration d'un filtre: permet de choisir uniquement des  *.bpel
                MonFiltre mft = 
                    new MonFiltre(new String[] { "xml" }, "XML Files (*.xml)");
                //ajout du filtre au JFileChooser
                fc.setFileFilter(mft);
                //fc.setApproveButtonText("Open");
                //fc.cance
                //// Le rpertoire source du JFileChooser est le rpertoire do est lanc notre programme
                fc.setCurrentDirectory(new File("."));
                //ouverture du JFileChooser et retour du rsultat de l'action de l'utilisateur
                res = fc.showOpenDialog(fc);


                //L'utilisateur clique sur annuler ou sur X --> le programme s'arrte
                if (res == JFileChooser.CANCEL_OPTION) {

                }
                //L'utilisateur choisit un fichier et clique sur ouvrir -->le programme continue son excution
                if (res == JFileChooser.APPROVE_OPTION) {
                    jtf1.setText(fc.getSelectedFile().getAbsolutePath());
                }

            } catch (Exception ex) {
            }
        }


    }
    class boutonParcourir1Listener implements ActionListener{
         int res;
         public void actionPerformed(ActionEvent e) {
                // System.out.println("TEXT : jtf " + jtf.getText());
                        try
                                {
                                
                                UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
                                UIManager.put("FileChooser.saveButtonText","Save");
                                UIManager.put("FileChooser.openButtonText","Open");
                                UIManager.put("FileChooser.cancelButtonText","Cancel");
                                UIManager.put("FileChooser.updateButtonText","Refresh");
                                UIManager.put("FileChooser.helpButtonText","Help");
                                UIManager.put("FileChooser.saveButtonToolTipText","Save File");//Cration d'une boite de dialogue pour choisir le fichier surlequel appliquer le programme
                                JFileChooser fc = new JFileChooser();
                                fc.setDialogTitle("Open File"); 
                                
                                //Cration d'un filtre: permet de choisir uniquement des  *.bpel
                                MonFiltre mft = new MonFiltre( new String[]{"bpel"},"BPEL Files (*.bpel)");
                                //ajout du filtre au JFileChooser
                                fc.setFileFilter(mft);
                                //fc.setApproveButtonText("Open");
                                //fc.cance
                                //// Le rpertoire source du JFileChooser est le rpertoire do est lanc notre programme
                                fc.setCurrentDirectory(new File(".")); 
                                //ouverture du JFileChooser et retour du rsultat de l'action de l'utilisateur
                                res = fc.showOpenDialog(fc);
                                
                                 
                                //L'utilisateur clique sur annuler ou sur X --> le programme s'arrte
                                 if(res == JFileChooser.CANCEL_OPTION) {
                                    
                                 }
                                //L'utilisateur choisit un fichier et clique sur ouvrir -->le programme continue son excution
                                 if (res == JFileChooser.APPROVE_OPTION) {
                                         jtfBPEL.setText(fc.getSelectedFile().getAbsolutePath());
                                }
                
                                }
                        catch (Exception ex){}
         }

    
    }
         
         class boutonExecutionListener implements ActionListener{
             
             public void actionPerformed(ActionEvent e) {
                    
                     //recuperer lechemin du fichier de la spcification
                     xmlFile = jtf1.getText();
                     // rcuprer le chemin du fichier de la composition
                     BPELPath = jtfBPEL.getText();
                     try{
                        RepetitionNumber = Integer.parseInt(jtf2.getText());
                     }
                     catch (Exception ex){
                     
                             JOptionPane jop3 = new JOptionPane();
                             jop3.showMessageDialog(null, "test execution number should be an integer!", "Error", JOptionPane.ERROR_MESSAGE);
                         }
                 try{
                    tmax = Integer.parseInt(jtf3.getText());
                 }
                 catch (Exception ex){
                     JOptionPane jop3 = new JOptionPane();
                     jop3.showMessageDialog(null, "Network timeout should be an integer!", "Error", JOptionPane.ERROR_MESSAGE);
                 }
                
                     
                    // System.out.println("nomFic = "+nomFic);
                    if (xmlFile.equalsIgnoreCase(".xml")||BPELPath.equalsIgnoreCase(".bpel")||(tmax==0)||(RepetitionNumber==0)){
                            //Bote du message d'erreur
                             JOptionPane jop3 = new JOptionPane();
                            jop3.showMessageDialog(null, "Please, insert the missing information(s) before executing!", "Error", JOptionPane.ERROR_MESSAGE);
                     }
                     else{
                             ex = true;

                     }
                 //TestDeConformite testDeConformite=new  TestDeConformite();
                 //testDeConformite.conformanceTest();
                             
             }
         }

}
