package Tester;


import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

import java.lang.reflect.Constructor;

import java.util.Iterator;
import java.util.List;
import org.jdom.Element;
import Tester.ConformanceTesting;
import Tester.BPELInvoker;

import java.lang.reflect.Method;


public class GuardInputTransition extends Transition {
State source;
State target;
String inputMsg= null;   
    public static final Class cString = getClass("java.lang.String");
    public static final Class cBoolean = getClass("java.lang.Boolean");
    public static final Class cInteger = getClass("java.lang.Integer");
    public static final Class cDouble = getClass("java.lang.Double");
    public static final Class cShort = getClass("java.lang.Short");
    public static final Class cLong = getClass("java.lang.Long");
    
   
    private static Class getClass(String nomClasse){
            Class laClasse = null;
            try {
                    laClasse = Class.forName(nomClasse);
            } catch (ClassNotFoundException e) {
                    e.printStackTrace();
            }
            return laClasse;
    }


    public GuardInputTransition(State source, State target){
            this.source =source;
            this.target=target;
    }

    String action(State source, State target) {
            TreatmentVariable tVar = new TreatmentVariable();
            TreatmentSpec tSpec= new TreatmentSpec(ConformanceTesting.TA);
            float n;

            //i_msg is the action done according to the specification
           String i_msg = tSpec.generateActionOfInputTransition(source, target);
            System.out.println("i_msg= " + i_msg);
            //randomly generate n based on the guard input transition
            //TODO gnrration valeur de clock automatiquement je l'ai dj fait dans un projet prcdent
            n = ((float)(Math.random() * (60000)))/1000;
            System.out.println("ninput= " + n);
            //if the current transition is the initial transition, 
            //first, generate input according to the the type of the BPEL input described in the (wsdl , xsd ) files of the BPEL
            //, invoke the BPEL process with this generated input 
            
            if ((this.source.id.equals(ConformanceTesting.s0.id))) {
            System.out.println(source.id + " is  initial State");
            //generating the input of the BPEL
            String BPELinput =tVar.DataGeneration(ConformanceTesting.typeBPELInput,5); 
            System.out.println("BPEL input generated = "+BPELinput);
            // TestDeConformite.gui.ta.append("inputBPEL: "+inputMsg+"\n");
            //invocation of BPEL process with input BPEL
            System.out.println("Connexion au client & invocation du BPEL");
            BPELInvoker.instancierBPEL(ConformanceTesting.BPELName,BPELinput);
            //in the case of initial state n = 0
            n=0;
            return "(" + i_msg + "("+inputMsg+") , " + n + ")";
        }
        else sendToTestExecution(ConformanceTesting.outputGeneration,ConformanceTesting.invokedPartnerServiceName);
       return "(" + i_msg + "("+ ConformanceTesting.outputGeneration+"), " + n + ")";

    }
    
    /**
     * used to send the input generated by tester to the according partner service  
     * @param generatedOutput
     * @param invokedPartnerService
     */
        
        
         public void sendToTestExecution(String generatedOutput, String invokedPartnerService){
            //firstly, instanciate the suitable class of the proxy of the invoked partner service
            //if service A is the current invoked partner service, we instanciate the class SendToParnerA
            //if service B is the current invoked partner service, we instanciate the class sendToPartnerB
            //so, we conclude that the class instantiated depends on the invoked web service
            // so, we instanciate the class by refenrring to the name of the partner service
             
             //get the name of the class proxy of the curent invoked partner service
             String className  = "Tester.SendToPartner".concat(invokedPartnerService);
             System.out.println(className);
             
              try {
                 //call the class by referring to ots name
                Class cl=Class.forName(className);
                //call the constructor of the class 
                Constructor constructeur = cl.getConstructor();
                // just to simplify we do the class String 
                //TODO : continue the other types a
                //typePar specifies the type of the parameter of the method to invoke
                Class typePar = cString;
                //invoke the method send response, this method allow to send the output generatedd by the tester
                //to the invoked partner service 
                Method mthd=cl.getMethod("sendResponse",typePar);
                mthd.invoke(constructeur.newInstance (),generatedOutput);
              } catch (Exception e) {
                e.printStackTrace();
              } 
            }
            public static void main (String args[]){
             GuardInputTransition it = new GuardInputTransition(new State ("id8"),new State("id5"));
                it.sendToTestExecution("manel","LBS");
            }
        
      
       
}


