/*
 * @(#)ConformanceTesting.java         12/01/31
 *
 * Copyright (c) .
  * All rights reserved.
 *
 * This software is the confidential and proprietary information of ReDCAD 
 * Reasearch Unit, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with ReDCAD.
 */
package tester;


import java.io.File;

import java.io.FileWriter;

import tester.Transition;

import java.io.IOException;

import java.io.PrintWriter;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.Iterator;
import java.util.List;


/**
 * Class description goes here.
 *
 * @version 	0.1 31 Jan 2012
 * @author 	Afef JMAL, Manel HAMZA
 */
public class Test {
        // Timed Automata TA 
      public static    String TA;
    //.bpel Path file
    public static String BPELPath;
    //the name of the deployed BPEL process
    public static String BPELName;
    // Number of test Execution 
    public static int N;
    // Network time out
    public static int tmax;
    //Initial State
    public static State s0;
    //type of BPELInput
    public static String typeBPELInput;
    //BPEL input
    public static Object inputBPEL;
    // the endPoint of the invoked partner service
     public static String invokedPartnerServiceEndPoint ;
    //the name of the current invoked partner service
        public static String invokedPartnerServiceName;
    //the response generated to the current invoked partner service 
    public static String outputGeneration;
    //the online test execution
     public static  TestRunning testRunning;
    //the test report for off line testing
    public static TestReport Report;
    //verdict of the test execution
    public static String verdict=null;
    
    
    //TODO to delete this file after just to try execution
    
    public static File QTestorFile = 
        new File("C:\\Documents and Settings\\TheJoKer\\Bureau\\FileTest.txt");

    public static void main(String[] args) throws IOException, Exception {
      
    
    //TODO to delete
        PrintWriter sortieTestor = null;
        
        
        try {
        // 'sortie' permet d'crire du texte dans un flux de caractres dirig
        // vers notre fichier QTestor.

        sortieTestor = new PrintWriter(new FileWriter(QTestorFile),true);
        } catch (IOException e) {
        // Si sa cration choue, on s'arrte.
        System.err.println("# Erreur : impossible de crer le fichier");
        System.exit(1);
        }
        
            //L'tat courant 
             State currentState;
            //la transition courante
            Transition currentTransition;
            // La liste qui contient tous les cas de test gnrs
            List<String> tcList = new ArrayList<String>();
            // La liste des transitions qui suivent l'tat courant
            List<Transition> acList = new ArrayList<Transition>();
            // la liste des locations de la spcification
            List<State> locationList = new ArrayList<State>();
            // la liste des locations qui sont suivies par un nombre de transition >=2
            List<State> locationAvec2Transitions = new ArrayList<State>();
            // extraction des  transitions de type Input, GuardInput, ou Timed transition  partir de acList
            List<Transition> itList = new ArrayList<Transition>();
            // extraction des  transitions de type Input, GuardInput, ou Timed transition  partir de acList
            List<Transition>  gVarList = new ArrayList<Transition>();
            //list des chemin parcourus
            List<String> pathsList = new ArrayList<String>();
            //List of covered actions in a choosen path
            List<String> tc = new ArrayList<String>();
            //the Index of the path choosen from the the pathsList
            int pathIndex =0;
            // a counter of a synchronised State
            int syncStateCounter =0;
            //a counter of transition to cross in path choosen 
            int TransitionIndex =0;
            
              Date today = Calendar.getInstance().getTime();
            sortieTestor.println(today);
            
            
        /********************************************************************************
        * Extract Inputs 
        * 1- Timed Automata TA, 
        * 2- BPEL Implementation Path, 
        * 3- Number of test Execution
        * 4- Network time out
        *******************************************************************************/

         Frame frame = new Frame ();
         TreatmentFrame ft = new TreatmentFrame(frame);
       
         /** 1- Timed Automata TA **/
         TA =ft.getSpecPath();
        sortieTestor.println(TA);
        sortieTestor.println();
            
    
               //Frame f = new Frame();
        Runtime runtime = Runtime.getRuntime();
        String[] ar = { "cmd.exe", "/C", "dir C:\\ >fichier.txt" };
        final Process process = runtime.exec(ar);
         
            
    }}