package Tester;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

import java.util.Calendar;
import java.util.Date;

public class TestReport {
    
    PrintWriter printWriterReport = null;

    public TestReport(String BPELName) {
        File Report = new File(".\\testReport.txt");

        

        try {
            printWriterReport = new PrintWriter(new FileWriter(Report), true);
        } catch (IOException e) {
            System.err.println("# Erreur : impossible de crer \"" + Report + 
                               "\".");
            System.exit(1);
        }
        Date today = Calendar.getInstance().getTime();
        System.out.println(today);
        printWriterReport.println("=================================================================================================================");
        printWriterReport.println(BPELName + 
                                  "ConformanceTesting                                          " + 
                                  today);
        printWriterReport.println("=================================================================================================================");
        printWriterReport.println();

    }
    public void setTestExecutionNumber(int numberOfTestExecution){
        printWriterReport.println("========================================================================================");
        printWriterReport.println("                                      Execution "+numberOfTestExecution);
        printWriterReport.println("========================================================================================");
        printWriterReport.println();
    }

}
